.TH compile 3 "compiler  4.6.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
compile \- Erlang Compiler
.SH DESCRIPTION
.LP
This module provides an interface to the standard Erlang compiler\&. It can generate either a new file which contains the object code, or return a binary which can be loaded directly\&. 

.SH EXPORTS
.LP
.B
file(File)
.br
.RS
.LP
Is the same as \fIfile(File, [verbose, report_errors, report_warnings])\fR\&. 
.RE
.LP
.B
file(File, Options) -> CompRet
.br
.RS
.TP
Types
CompRet = ModRet | BinRet | ErrRet
.br
ModRet = {ok, ModuleName} | {ok, ModuleName, Warnings}
.br
BinRet = {ok, ModuleName, Binary} | {ok, ModuleName, Binary, Warnings}
.br
ErrRet = error | {error, Errors, Warnings}
.br
.RE
.RS
.LP
Compiles the code in the file \fIFile\fR, which is an Erlang source code file without the \fI\&.erl\fR extension\&. \fIOptions\fR determine the behavior of the compiler\&.
.LP
Returns \fI{ok, ModuleName}\fR if successful, or \fIerror\fR if there are errors\&. An object code file is created if the compilation succeeds with no errors\&. It is considered to be an error if the module name in the source code is not the same as the basename of the output file\&.
.LP
Here follows first all elements of \fIOptions\fR that in some way control the behavior of the compiler\&.
.RS 2
.TP 4
.B
\fIbasic_validation\fR:
This option is fast way to test whether a module will compile successfully (mainly useful for code generators that want to verify the code they emit)\&. No code will generated\&. If warnings are enabled, warnings generated by the \fIerl_lint\fR module (such as warnings for unused variables and functions) will be returned too\&.
.RS 4
.LP

.LP
Use the \fIstrong_validation\fR option to generate all warnings that the compiler would generate\&.
.RE
.TP 4
.B
\fIstrong_validation\fR:
Similar to the \fIbasic_validation\fR option, no code will be generated, but more compiler passes will be run to ensure also warnings generated by the optimization passes are generated (such as clauses that will not match or expressions that are guaranteed to fail with an exception at run-time)\&.
.TP 4
.B
\fIbinary\fR:
Causes the compiler to return the object code in a binary instead of creating an object file\&. If successful, the compiler returns \fI{ok, ModuleName, Binary}\fR\&.
.TP 4
.B
\fIbin_opt_info\fR:
The compiler will emit informational warnings about binary matching optimizations (both successful and unsuccesful)\&. See the \fIEfficiency Guide\fR for further information\&.
.TP 4
.B
\fIcompressed\fR:
The compiler will compress the generated object code, which can be useful for embedded systems\&.
.TP 4
.B
\fIdebug_info\fR:
 
.RS 4
.LP
Include debug information in the form of abstract code (see The Abstract Format in ERTS User\&'s Guide) in the compiled beam module\&. Tools such as Debugger, Xref and Cover require the debug information to be included\&.
.LP

.LP
\fIWarning\fR: Source code can be reconstructed from the debug information\&. Use encrypted debug information (see below) to prevent this\&.
.LP

.LP
See beam_lib(3) for details\&.
.RE
.TP 4
.B
\fI{debug_info_key, KeyString}\fR:
.TP 4
.B
\fI{debug_info_key, {Mode, KeyString}}\fR:
 
.RS 4
.LP
Include debug information, but encrypt it, so that it cannot be accessed without supplying the key\&. (To give the \fIdebug_info\fR option as well is allowed, but is not necessary\&.) Using this option is a good way to always have the debug information available during testing, yet protect the source code\&.
.LP

.LP
\fIMode\fR is the type of crypto algorithm to be used for encrypting the debug information\&. The default type -- and currently the only type -- is \fIdes3_cbc\fR\&.
.LP

.LP
See beam_lib(3) for details\&.
.RE
.TP 4
.B
\fIencrypt_debug_info\fR:
 
.RS 4
.LP
Like the \fIdebug_info_key\fR option above, except that the key will be read from an \fI\&.erlang\&.crypt\fR file\&. 
.LP

.LP
See beam_lib(3) for details\&.
.RE
.TP 4
.B
\fI\&'P\&'\fR:
Produces a listing of the parsed code after preprocessing and parse transforms, in the file \fI<File>\&.P\fR\&. No object file is produced\&. 
.TP 4
.B
\fI\&'E\&'\fR:
Produces a listing of the code after all source code transformations have been performed, in the file \fI<File>\&.E\fR\&. No object file is produced\&. 
.TP 4
.B
\fI\&'S\&'\fR:
Produces a listing of the assembler code in the file \fI<File>\&.S\fR\&. No object file is produced\&. 
.TP 4
.B
\fIreport_errors/report_warnings\fR:
Causes errors/warnings to be printed as they occur\&.
.TP 4
.B
\fIreport\fR:
This is a short form for both \fIreport_errors\fR and \fIreport_warnings\fR\&.
.TP 4
.B
\fIreturn_errors\fR:
If this flag is set, then \fI{error, ErrorList, WarningList}\fR is returned when there are errors\&.
.TP 4
.B
\fIreturn_warnings\fR:
If this flag is set, then an extra field containing \fIWarningList\fR is added to the tuples returned on success\&.
.TP 4
.B
\fIreturn\fR:
This is a short form for both \fIreturn_errors\fR and \fIreturn_warnings\fR\&.
.TP 4
.B
\fIverbose\fR:
Causes more verbose information from the compiler describing what it is doing\&.
.TP 4
.B
\fI{outdir, Dir}\fR:
Sets a new directory for the object code\&. The current directory is used for output, except when a directory has been specified with this option\&.
.TP 4
.B
\fIexport_all\fR:
Causes all functions in the module to be exported\&.
.TP 4
.B
\fI{i, Dir}\fR:
Add \fIDir\fR to the list of directories to be searched when including a file\&. When encountering an \fI-include\fR or \fI-include_dir\fR directive, the compiler searches for header files in the following directories:
.RS 4
.LP

.RS 2
.TP 4
1.
\fI"\&."\fR, the current working directory of the file server;
.TP 4
2.
the base name of the compiled file;
.TP 4
3.
the directories specified using the \fIi\fR option\&. The directory specified last is searched first\&.
.RE
.RE
.TP 4
.B
\fI{d, Macro}\fR:
.TP 4
.B
\fI{d, Macro, Value}\fR:
Defines a macro \fIMacro\fR to have the value \fIValue\fR\&. The default is \fItrue\fR)\&.
.TP 4
.B
\fI{parse_transform, Module}\fR:
Causes the parse transformation function \fIModule:parse_transform/2\fR to be applied to the parsed code before the code is checked for errors\&.
.TP 4
.B
\fIasm\fR:
The input file is expected to be assembler code (default file suffix "\&.S")\&. Note that the format of assembler files is not documented, and may change between releases - this option is primarily for internal debugging use\&.
.TP 4
.B
\fIno_strict_record_tests\fR:
This option is not recommended\&.
.RS 4
.LP

.LP
By default, the generated code for the \fIRecord#record_tag\&.field\fR operation verifies that the tuple \fIRecord\fR is of the correct size for the record and that the first element is the tag \fIrecord_tag\fR\&. Use this option to omit the verification code\&.
.RE
.TP 4
.B
\fIno_error_module_mismatch\fR:
Normally the compiler verifies that the module name given in the source code is the same as the base name of the output file and refuses to generate an output file if there is a mismatch\&. If you have a good reason (or other reason) for having a module name unrelated to the name of the output file, this option disables that verification (there will not even be a warning if there is a mismatch)\&.
.RE
.LP
If warnings are turned on (the \fIreport_warnings\fR option described above), the following options control what type of warnings that will be generated\&.  With the exception of \fI{warn_format, Verbosity}\fR all options below have two forms; one \fIwarn_xxx\fR form to turn on the warning and one \fInowarn_xxx\fR form to turn off the warning\&. In the description that follows, the form that is used to change the default value is listed\&.
.RS 2
.TP 4
.B
\fI{warn_format, Verbosity}\fR:
Causes warnings to be emitted for malformed format strings as arguments to \fIio:format\fR and similar functions\&. \fIVerbosity\fR selects the amount of warnings: 0 = no warnings; 1 = warnings for invalid format strings and incorrect number of arguments; 2 = warnings also when the validity could not be checked (for example, when the format string argument is a variable)\&. The default verbosity is 1\&. Verbosity 0 can also be selected by the option \fInowarn_format\fR\&.
.TP 4
.B
\fInowarn_bif_clash\fR:
By default, there will be a compilation error if a module contains an exported function with the same name as an auto-imported BIF (such as \fIsize/1\fR) AND there is a call to it without a qualifying module name\&. The reason is that the BIF will be called, not the function in the same module\&. The recommended way to eliminate that warning is to use a call with a module name - either \fIerlang\fR to call the BIF or \fI?MODULE\fR to call the function in the same module\&. The warning can also be turned off using this option, but that is not recommended\&.
.RS 4
.LP

.LP
\fIThe use of this option is strongly discouraged, as code that uses it will probably break in a future major release (R14 or R15)\&.\fR
.RE
.TP 4
.B
\fI{nowarn_bif_clash, FAs}\fR:
Turns off warnings as \fInowarn_bif_clash\fR but only for the mentioned local functions\&. \fIFAs\fR is a tuple \fI{Name, Arity}\fR or a list of such tuples\&.
.RS 4
.LP

.LP
\fIThe use of this option is strongly discouraged, as code that uses it will probably break in a future major release (R14 or R15)\&.\fR
.RE
.TP 4
.B
\fIwarn_export_all\fR:
Causes a warning to be emitted if the \fIexport_all\fR option has also been given\&.
.TP 4
.B
\fIwarn_export_vars\fR:
Causes warnings to be emitted for all implicitly exported variables referred to after the primitives where they were first defined\&. No warnings for exported variables unless they are referred to in some pattern, which is the default, can be selected by the option \fInowarn_export_vars\fR\&.
.TP 4
.B
\fIwarn_shadow_vars\fR:
Causes warnings to be emitted for "fresh" variables in functional objects or list comprehensions with the same name as some already defined variable\&. The default is to warn for such variables\&. No warnings for shadowed variables can be selected by the option \fInowarn_shadow_vars\fR\&.
.TP 4
.B
\fInowarn_unused_function\fR:
Turns off warnings for unused local functions\&. By default (\fIwarn_unused_function\fR), warnings are emitted for all local functions that are not called directly or indirectly by an exported function\&. The compiler does not include unused local functions in the generated beam file, but the warning is still useful to keep the source code cleaner\&.
.TP 4
.B
\fI{nowarn_unused_function, FAs}\fR:
Turns off warnings for unused local functions as \fInowarn_unused_function\fR but only for the mentioned local functions\&. \fIFAs\fR is a tuple \fI{Name, Arity}\fR or a list of such tuples\&.
.TP 4
.B
\fInowarn_deprecated_function\fR:
Turns off warnings for calls to deprecated functions\&. By default (\fIwarn_deprecated_function\fR), warnings are emitted for every call to a function known by the compiler to be deprecated\&. Note that the compiler does not know about the \fI-deprecated()\fR attribute but uses an assembled list of deprecated functions in Erlang/OTP\&. To do a more general check the \fIXref\fR tool can be used\&. See also xref(3) and the function xref:m/1 also accessible through the c:xm/1 function\&.
.TP 4
.B
\fI{nowarn_deprecated_function, MFAs}\fR:
Turns off warnings for calls to deprecated functions as \fInowarn_deprecated_function\fR but only for the mentioned functions\&. \fIMFAs\fR is a tuple \fI{Module, Name, Arity}\fR or a list of such tuples\&.
.TP 4
.B
\fIwarn_obsolete_guard\fR:
Causes warnings to be emitted for calls to old type testing BIFs such as \fIpid/1\fR and \fIlist/1\fR\&. See the Erlang Reference Manual for a complete list of type testing BIFs and their old equivalents\&. No warnings for calls to old type testing BIFs, which is the default, can be selected by the option \fInowarn_obsolete_guard\fR\&.
.TP 4
.B
\fIwarn_unused_import\fR:
Causes warnings to be emitted for unused imported functions\&. No warnings for unused imported functions, which is the default, can be selected by the option \fInowarn_unused_import\fR\&. 
.TP 4
.B
\fInowarn_unused_vars\fR:
By default, warnings are emitted for variables which are not used, with the exception of variables beginning with an underscore ("Prolog style warnings")\&. Use this option to turn off this kind of warnings\&.
.TP 4
.B
\fInowarn_unused_record\fR:
Turns off warnings for unused record types\&. By default (\fIwarn_unused_records\fR), warnings are emitted for unused locally defined record types\&.
.RE
.LP
Another class of warnings is generated by the compiler during optimization and code generation\&. They warn about patterns that will never match (such as \fIa=b\fR), guards that will always evaluate to false, and expressions that will always fail (such as \fIatom+42\fR)\&.
.LP
Note that the compiler does not warn for expressions that it does not attempt to optimize\&. For instance, the compiler tries to evaluate \fI1/0\fR, notices that it will cause an exception and emits a warning\&. On the other hand, the compiler is silent about the similar expression \fIX/0\fR; because of the variable in it, the compiler does not even try to evaluate and therefore it emits no warnings\&. 
.LP
Currently, those warnings cannot be disabled (except by disabling all warnings)\&.
.SS Warning:
.LP
Obviously, the absence of warnings does not mean that there are no remaining errors in the code\&.

.LP
Note that all the options except the include path (\fI{i, Dir}\fR) can also be given in the file with a \fI-compile([Option, \&.\&.\&.])\fR\&. attribute\&. The \fI-compile()\fR attribute is allowed after function definitions\&.
.LP
Note also that the \fI{nowarn_unused_function, FAs}\fR, \fI{nowarn_bif_clash, FAs}\fR, and \fI{nowarn_deprecated_function, MFAs}\fR options are only recognized when given in files\&. They are not affected by the \fIwarn_unused_function\fR, \fIwarn_bif_clash\fR, or \fIwarn_deprecated_function\fR options\&.
.LP
For debugging of the compiler, or for pure curiosity, the intermediate code generated by each compiler pass can be inspected\&. A complete list of the options to produce list files can be printed by typing \fIcompile:options()\fR at the Erlang shell prompt\&. The options will be printed in order that the passes are executed\&. If more than one listing option is used, the one representing the earliest pass takes effect\&.
.LP
\fIUnrecognized options are ignored\&.\fR
.LP
Both \fIWarningList\fR and \fIErrorList\fR have the following format:

.nf
[{FileName,[ErrorInfo]}]\&.
        
.fi
.LP
\fIErrorInfo\fR is described below\&. The file name has been included here as the compiler uses the Erlang pre-processor \fIepp\fR, which allows the code to be included in other files\&. For this reason, it is important to know to \fIwhich\fR file an error or warning line number refers\&. 
.RE
.LP
.B
forms(Forms)
.br
.RS
.LP
Is the same as \fIforms(File, [verbose, report_errors, report_warnings])\fR\&. 
.RE
.LP
.B
forms(Forms, Options) -> CompRet
.br
.RS
.TP
Types
Forms = [Form]
.br
CompRet = BinRet | ErrRet
.br
BinRet = {ok, ModuleName, BinaryOrCode} | {ok, ModuleName, BinaryOrCode, Warnings}
.br
BinaryOrCode = binary() | term()
.br
ErrRet = error | {error, Errors, Warnings}
.br
.RE
.RS
.LP
Analogous to \fIfile/1\fR, but takes a list of forms (in the Erlang abstract format representation) as first argument\&. The option \fIbinary\fR is implicit; i\&.e\&., no object code file is produced\&. Options that would ordinarily produce a listing file, such as \&'E\&', will instead cause the internal format for that compiler pass (an Erlang term; usually not a binary) to be returned instead of a binary\&.
.RE
.LP
.B
format_error(ErrorDescriptor) -> chars()
.br
.RS
.TP
Types
ErrorDescriptor = errordesc()
.br
.RE
.RS
.LP
Uses an \fIErrorDescriptor\fR and returns a deep list of characters which describes the error\&. This function is usually called implicitly when an \fIErrorInfo\fR structure is processed\&. See below\&.
.RE
.LP
.B
output_generated(Options) -> true | false
.br
.RS
.TP
Types
Options = [term()]
.br
.RE
.RS
.LP
Determines whether the compiler would generate a \fIbeam\fR file with the given options\&. \fItrue\fR means that a \fIbeam\fR file would be generated; \fIfalse\fR means that the compiler would generate some listing file, return a binary, or merely check the syntax of the source code\&.
.RE
.LP
.B
noenv_file(File, Options) -> CompRet
.br
.RS
.LP
Works exactly like file/2, except that the environment variable \fIERL_COMPILER_OPTIONS\fR is not consulted\&.
.RE
.LP
.B
noenv_forms(Forms, Options) -> CompRet
.br
.RS
.LP
Works exactly like forms/2, except that the environment variable \fIERL_COMPILER_OPTIONS\fR is not consulted\&.
.RE
.LP
.B
noenv_output_generated(Options) -> true | false
.br
.RS
.TP
Types
Options = [term()]
.br
.RE
.RS
.LP
Works exactly like output_generated/1, except that the environment variable \fIERL_COMPILER_OPTIONS\fR is not consulted\&.
.RE
.SH DEFAULT COMPILER OPTIONS
.LP
The (host operating system) environment variable \fIERL_COMPILER_OPTIONS\fR can be used to give default compiler options\&. Its value must be a valid Erlang term\&. If the value is a list, it will be used as is\&. If it is not a list, it will be put into a list\&.
.LP
The list will be appended to any options given to file/2, forms/2, and output_generated/2\&. Use the alternative functions noenv_file/2, noenv_forms/2, or noenv_output_generated/2 if you don\&'t want the environment variable to be consulted (for instance, if you are calling the compiler recursively from inside a parse transform)\&.
.SH INLINING
.LP
The compiler can do function inlining within an Erlang module\&. Inlining means that a call to a function is replaced with the function body with the arguments replaced with the actual values\&. The semantics are preserved, except if exceptions are generated in the inlined code\&. Exceptions will be reported as occurring in the function the body was inlined into\&. Also, \fIfunction_clause\fR exceptions will be converted to similar \fIcase_clause\fR exceptions\&.
.LP
When a function is inlined, the original function will be kept if it is exported (either by an explicit export or if the \fIexport_all\fR option was given) or if not all calls to the function were inlined\&.
.LP
Inlining does not necessarily improve running time\&. For instance, inlining may increase Beam stack usage which will probably be detrimental to performance for recursive functions\&. 
.LP
Inlining is never default; it must be explicitly enabled with a compiler option or a \fI-compile()\fR attribute in the source module\&.
.LP
To enable inlining, either use the \fIinline\fR option to let the compiler decide which functions to inline or \fI{inline, [{Name, Arity}, \&.\&.\&.]}\fR to have the compiler inline all calls to the given functions\&. If the option is given inside a \fIcompile\fR directive in an Erlang module, \fI{Name, Arity}\fR may be written as \fIName/Arity\fR\&.
.LP
Example of explicit inlining:

.nf
-compile({inline,[pi/0]})\&.

pi() -> 3\&.1416\&.
    
.fi
.LP
Example of implicit inlining:

.nf
-compile(inline)\&.
    
.fi
.LP
The \fI{inline_size, Size}\fR option controls how large functions that are allowed to be inlined\&. Default is \fI24\fR, which will keep the size of the inlined code roughly the same as the un-inlined version (only relatively small functions will be inlined)\&.
.LP
Example:

.nf
%% Aggressive inlining - will increase code size\&.
-compile(inline)\&.
-compile({inline_size,100})\&.
    
.fi
.SH PARSE TRANSFORMATIONS
.LP
Parse transformations are used when a programmer wants to use Erlang syntax but with different semantics\&. The original Erlang code is then transformed into other Erlang code\&.
.SH ERROR INFORMATION
.LP
The \fIErrorInfo\fR mentioned above is the standard \fIErrorInfo\fR structure which is returned from all IO modules\&. It has the following format:

.nf
{ErrorLine, Module, ErrorDescriptor}
    
.fi
.LP
A string describing the error is obtained with the following call:

.nf
apply(Module, format_error, ErrorDescriptor)
    
.fi
.SH SEE ALSO
.LP
epp(3), erl_id_trans(3), erl_lint(3), beam_lib(3) 
